package anonvpn.anon_next.core.networking.TcpSocks;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.util.Arrays;

import HTTPClient.HTTPClientSocketFactory;
import anon.AnonChannel;
import anon.client.AnonTCPChannel;
import anonvpn.anon_next.core.networking.INetworkFactory;

/**
 * Created by nod on 8/8/17.
 */

public class AnonTcpChannelDummy extends AnonTCPChannel {

    private Socket socket;
    private HTTPClientSocketFactory mMixSocketFactory;
    private InputStream is;
    private OutputStream os;

    protected AnonTcpChannelDummy(HTTPClientSocketFactory mMixSocketFactory) {
        super(null);

        this.mMixSocketFactory = mMixSocketFactory;
        try {
            socket = new Socket();
            socket.bind(null);

        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void connect(String hostname, int port) throws IOException {
        if(socket == null) throw new IOException("SOCKS SOCKET NOT INITIALIZED");

        Socket socket = mMixSocketFactory.connect(InetAddress.getByAddress(new byte[]{(byte) 0xC0, (byte) 0xA8, 0x08, 0x78/*0x0a, 0x64, 0x0e, (byte)0xf0*/}), 1080);
        is = socket.getInputStream();
        os = socket.getOutputStream();

        int len = hostname.length();

        byte[] out = {0x05, 0x01, 0x00};
        os.write(out);
        os.flush();

        byte[] in = new byte[2];

        int i = is.read(in, 0, 2);
        if(!Arrays.equals(in, new byte[]{0x05, 0x00})) throw new IOException("SOCKS SERVER RESPONSE NON CONFORM");

        out = new byte[len + 7];
        out[0] = 0x05;
        out[1] = 0x01;
        out[2] = 0x00;
        out[3] = 0x03;
        out[4] = (byte) len;
        for(int j = 0; j < len; ++j)
        {
            out[5 + j] = (byte) hostname.charAt(j);
        }
        out[5 + len] = (byte)(port >>> 8);
        out[6 + len] = (byte)(port);

        os.write(out);
        os.flush();

        in = new byte[10];
        is.read(in, 0, 10);

        if(in[1] == 0) /*System.out.println("DUMMY SOCKET CONNECTED SUCCESSFULLY TO: " + hostname)*/;
        else System.out.println("DUMMY SOCKET CONNECT FAILED");

    }

    public void setSentAutoFlushDelay(int msAutoFlushDelay) {
    }

    public InputStream getInputStream() {
            return is;
    }

    public OutputStream getOutputStream() {
        return os;
    }

    public int getOutputBlockSize() {
        return 0;
    }

    public void close() {
        try {
            socket.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public boolean isClosed() {
        return socket.isClosed();
    }
}
