package anonvpn.anon_next.core.networking.TcpSocks;

import java.util.HashSet;
import java.util.Iterator;

/**
 * Created by nod on 9/26/17.
 */

final class UdpTimer implements Runnable
	{

		// timeout in milliseconds
		private final static int TIMEOUT = 10000;
		// waiting time in milliseconds
		private final static int WAITINGTIME = 1000;
		HashSet<UdpStream> streams = new HashSet<>();
		private volatile boolean m_bRun;

		private Thread m_Thread;
		public UdpTimer()
			{
				m_bRun=true;

			}

		public synchronized void addUdpStream(UdpStream stream)
			{
				streams.add(stream);
			}

		public synchronized void removeUdpStream(UdpStream stream)
			{
				streams.remove(stream);
			}
		
		public void start()
		{
			m_Thread=new Thread(this,"UDP Timer");
			m_Thread.setDaemon(true);
			m_bRun=true;
			m_Thread.start();
		}

		public void stop()
		{
			m_bRun=false;
			m_Thread.interrupt();
			m_Thread=null;
		}

		@Override
		public void run()
			{
				long cTime;

				while (m_bRun)
					{

						cTime = System.currentTimeMillis();
						synchronized (this)
							{
								for (Iterator<UdpStream> i = streams.iterator(); i.hasNext(); )
									{
										{
											UdpStream stream = i.next();
											if (stream.getLastTimeStamp() < cTime - TIMEOUT)
												{
													stream.close(false);
													i.remove();
												}
										}
									}
							}
						try
							{
								Thread.sleep(WAITINGTIME);
							}
						catch (InterruptedException e)
							{
							}

					}
			}
	}
