package anonvpn.anon_next.core.notification;

import java.util.HashMap;
import java.util.LinkedList;

public class NotificationDispatcher
	{

		private HashMap<Event, LinkedList<Observer>> mSubscriptions;

		public NotificationDispatcher()
			{
				mSubscriptions = new HashMap<Event, LinkedList<Observer>>();
			}

		public synchronized void subscribe(final Event event, Observer observer)
			{

				if (mSubscriptions.containsKey(event) == false)
					{
						mSubscriptions.put(event, new LinkedList<Observer>());
					}
				mSubscriptions.get(event).add(observer);
			}

		public synchronized void unsubscribe(final Event event, Observer observer)
			{

				if (mSubscriptions.containsKey(event)) {

					mSubscriptions.get(event).remove(observer);

				}

			}

		public synchronized void notify(final Event event)
			{

				if (mSubscriptions.containsKey(event))
					{

						for (Observer obs : mSubscriptions.get(event))
							{
								obs.notify(event);
							}

					}
			}

		public synchronized void notifyAsync(final Event event) {

			Thread notifyThread = new Thread(new Runnable() {
				@Override
				public void run() {
					NotificationDispatcher.this.notify(event);
				}
			});
			notifyThread.start();

		}
	}
