package pcap;

import java.io.IOException;

import anonvpn.anon_next.core.entities.IPv4Packet;
import anonvpn.anon_next.core.networking.ITunneling;

public class PCAPTUNDevice implements ITunneling
	{
		ITunneling m_Device;
		PCAPWriter m_PCAP;
		
public PCAPTUNDevice(ITunneling device,String pcapFilename)
{
	m_Device=device;
	try
		{
			m_PCAP=new PCAPWriter(pcapFilename);
		}
	catch (Exception e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
}

public PCAPTUNDevice(ITunneling device,PCAPWriter writer)
{
	m_Device=device;
	try
		{
			m_PCAP=writer;
		}
	catch (Exception e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
}

		
	@Override
	public void writePacket(IPv4Packet pkt) throws IOException
		{
			try
				{
					m_PCAP.dumpIPPacket(pkt.getRawPacket(),0,pkt.getLength());
				}
			catch (Exception e)
				{
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			m_Device.writePacket(pkt);
			// TODO Auto-generated method stub
			
		}

	@Override
	public void write(byte[] ar, int off, int len) throws IOException
		{
			try
				{
					m_PCAP.dumpIPPacket(ar,off,len);
				}
			catch (Exception e)
				{
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			m_Device.write(ar,off,len);			
		}

	@Override
	public IPv4Packet readPacket() throws IOException
		{
			IPv4Packet pkt= m_Device.readPacket();
			try
				{
					m_PCAP.dumpIPPacket(pkt.getRawPacket(),0,pkt.getLength());
				}
			catch (Exception e)
				{
					// TODO Auto-generated catch block
					e.printStackTrace();
				}	
			return pkt;
		}

	@Override
	public int getMTU()
		{
			// TODO Auto-generated method stub
			return m_Device.getMTU();
		}

	@Override
	public int getIP()
		{
			return m_Device.getIP();
		}

	}
