package anonvpn.anon_next.core;

import anon.client.AnonUDPChannel;
import anon.client.UDPPacketStreamDesynchronisationException;
import anon.client.UDPPacketToLargeException;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class TestUDPChannel extends AnonUDPChannel {

    TestChannel mChannel;
    public String mHostname;
    public int mPort;
    public int mSrcPort;

    public TestUDPChannel(TestChannel channel) {
        super(channel);
        mChannel = channel;
    }

    @Override
    public void setDestination(String host, int port) {
        super.setDestination(host, port);
        mHostname = host;
        mPort = port;
    }

    @Override
    public void setSourcePort(int port) {
        super.setSourcePort(port);
        mSrcPort = port;
    }

    @Override
    public int readPacket(byte[] payload, int off, int len) throws IOException, UDPPacketStreamDesynchronisationException, UDPPacketToLargeException {
        return -1;
    }

    @Override
    public InputStream getInputStream() {
        return mChannel.getInputStream();
    }


    @Override
    public OutputStream getOutputStream() {
        return mChannel.getOutputStream();
    }
}
