package anonvpn.anon_next.core.networking.mocks;

import java.io.IOException;
import java.nio.ByteBuffer;
import java.util.LinkedList;
import java.util.List;

import anonvpn.anon_next.core.entities.IPv4Packet;
import anonvpn.anon_next.core.networking.ITunneling;


/**
 * Created by martin on 8/3/17.
 */

public class TestTunnelingInterface implements ITunneling {

    public List<IPv4Packet> mAvailablePackets = new LinkedList<IPv4Packet>();
    public List<ByteBuffer> mWrittenPackets = new LinkedList<ByteBuffer>();

    @Override
    public void writePacket(IPv4Packet pkt) throws IOException {

        ByteBuffer buffer = ByteBuffer.wrap(pkt.getRawPacket());
        mWrittenPackets.add(buffer);

    }

    @Override
    public void write(byte[] ar, int off, int len) throws IOException {

        ByteBuffer buffer = ByteBuffer.allocate(len - off + 1);
        for(int i = off; i < len; i++) {
            buffer.put(ar[i]);
        }
        mWrittenPackets.add(buffer);
    }

    @Override
    public IPv4Packet readPacket() throws IOException {
        IPv4Packet result = null;
        if (mAvailablePackets.size() > 0) {
            result = mAvailablePackets.get(0);
            mAvailablePackets.remove(0);
        } else {
            throw new IOException("Test Interface - no packets available!");
        }
        return result;
    }

    @Override
    public int getMTU() {
        return 1500;
    }

		@Override
		public int getIP()
			{
				// TODO Auto-generated method stub
				return 0x0a000002;
			}
}
