package anonvpn.anon_next.core.persistence.mocks;

import anon.infoservice.MixCascade;
import anonvpn.anon_next.core.persistence.IConfig;

import java.util.HashMap;
import java.util.Map;

public class TestConfig implements IConfig {

    Map<String, String> mStrings = new HashMap<String, String>();
    Map<String, Integer> mInts = new HashMap<String, Integer>();
    MixCascade mChosen = null;

    @Override
    public void setString(String key, String data) {
        mStrings.put(key, data);
    }

    @Override
    public void setInt(String key, int data) {
        mInts.put(key, data);
    }

    @Override
    public String getString(String key, String defaultValue) {
        String result = mStrings.get(key);
        if (result == null) {
            result = defaultValue;
        }
        return result;
    }

    @Override
    public int getInt(String key, int defaultValue) {
        Integer result = mInts.get(key);
        if (result == null) {
            result = defaultValue;
        }
        return result;
    }

    @Override
    public MixCascade getChosenMixCascade() {
        return mChosen;
    }

    @Override
    public void setChosenMixCascade(MixCascade cascade) {
        mChosen = cascade;
    }

    @Override
    public String getChosenCascadeCredential() {
        return null;
    }

    @Override
    public void setChosenCascadeCredential(String credential) {

    }

    @Override
    public void addSentBytes(int bytes) {

    }

    @Override
    public long getSentBytes() {
        return 0;
    }

    @Override
    public void addReceivedBytes(int bytes) {

    }

    @Override
    public long getReceivedBytes() {
        return 0;
    }

    @Override
    public void setSentBytes(long bytes) {

    }

    @Override
    public void setReceivedBytes(long bytes) {

    }
}
