package anonvpn.anon_next.android.service.networking;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;

import anonvpn.anon_next.core.networking.IConnectivityMonitor;
import anonvpn.anon_next.core.notification.Event;
import anonvpn.anon_next.core.notification.NotificationDispatcher;

/**
 * Created by martin on 03.04.18.
 */

public class AndroidConnectivityMonitor extends BroadcastReceiver implements IConnectivityMonitor {

    private final NotificationDispatcher mNotification;
    private final ConnectivityManager mConnectivityManager;
    private boolean mConnected = false;

    public AndroidConnectivityMonitor(NotificationDispatcher dispatcher, ConnectivityManager connManager) {

        mNotification = dispatcher;

        mConnectivityManager = connManager;

        NetworkInfo activeNetwork = mConnectivityManager.getActiveNetworkInfo();
        mConnected = activeNetwork != null &&
                activeNetwork.isConnectedOrConnecting();


    }

    @Override
    public void onReceive(Context context, Intent intent) {

        NetworkInfo activeNetwork = mConnectivityManager.getActiveNetworkInfo();

        boolean connected = activeNetwork != null &&
                activeNetwork.isConnectedOrConnecting();

        if (! mConnected && connected) {
            mConnected = connected;
            //System.out.println("Network connected!");
            mNotification.notify(Event.NETWORK_CONNECTED);

        }

        if (mConnected && ! connected) {
            mConnected = connected;
            //System.out.println("Network disconnected!");
            mNotification.notify(Event.NETWORK_DISCONNECTED);

        }
    }

    @Override
    public boolean deviceIsConnected() {
        return mConnected;
    }
}
