package anonvpn.anon_next.android.service.networking;

import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.net.ConnectivityManager;

import anonvpn.anon_next.core.networking.IConnectivityMonitor;
import anonvpn.anon_next.core.networking.IConnectivityMonitorFactory;
import anonvpn.anon_next.core.notification.NotificationDispatcher;

/**
 * Created by martin on 06.04.18.
 */

public class AndroidConnectivityMonitorFactory implements IConnectivityMonitorFactory {

    private final ConnectivityManager mConnectivityManager;
    private final Context mAppContext;

    public AndroidConnectivityMonitorFactory(Context context) {
        mAppContext = context;
        ConnectivityManager cm =
                (ConnectivityManager)mAppContext.getSystemService(Context.CONNECTIVITY_SERVICE);
        mConnectivityManager = cm;
    }

    @Override
    public IConnectivityMonitor getConnectivityMonitor(NotificationDispatcher notificationDispatcher) {
        AndroidConnectivityMonitor result = new AndroidConnectivityMonitor(notificationDispatcher, mConnectivityManager);
        IntentFilter filter = new IntentFilter(ConnectivityManager.CONNECTIVITY_ACTION);
        mAppContext.registerReceiver(result, filter);
        return result;
    }
}
