package anonvpn.anon_next.android.ui.main;


import android.app.Activity;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.text.InputType;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.Toast;

import androidx.annotation.Nullable;
import androidx.appcompat.app.AlertDialog;
import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;
import anon.infoservice.MixCascade;
import anon.util.XMLUtil;
import anonvpn.anon_next.android.R;
import anonvpn.anon_next.android.ui.VPNConnectedActivity;
import anonvpn.anon_next.android.ui.tutorial.TutorialActivity;

/*import com.google.android.gms.maps.CameraUpdate;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.MapView;
import com.google.android.gms.maps.OnMapReadyCallback;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.LatLngBounds;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;
import com.google.android.gms.maps.model.PolylineOptions;
*/

/**
 * A simple {@link Fragment} subclass.
 */
public class ConnectFragment extends Fragment implements ConnectListFragment.OnFragmentInteractionListener, ConnectButtonFragment.OnFragmentInteractionListener
	{
		private FragmentManager mFragmentManager;
		private Fragment mConnectFragmentCached;
		public boolean WAITING_FOR_CASCADE_CONNECTED = false;
		private MixCascade mMarkedCascade;
		private MixCascade mDetailCascade;

		private static String LOGTAG = "ConnectFragment.java";

		public ConnectFragment()
			{
			}

		@Override
		public void onCreate(Bundle savedInstanceState)
			{
				super.onCreate(savedInstanceState);
			}

		@Nullable
		@Override
		public View onCreateView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState)
			{
				super.onCreateView(inflater, container, savedInstanceState);
				View view = inflater.inflate(R.layout.fragment_connect, container, false);
				return view;
			}


		@Override
		public void onViewCreated(View view, Bundle savedInstanceState)
			{
				super.onViewCreated(view, savedInstanceState);
				if (!((VPNConnectedActivity) getActivity()).isVPNConnected())
					{
						throw new AssertionError("Started ConnectFragment without connection to VPN service!");
					}

				mFragmentManager = getChildFragmentManager();

				ConnectListFragment listFragment = new ConnectListFragment();
				listFragment.setInteractionListener(this);
				ConnectButtonFragment buttonFragment = new ConnectButtonFragment();
				buttonFragment.setInteractionListener(this);
				FragmentTransaction transaction = mFragmentManager.beginTransaction();
				transaction.add(R.id.connect_layout_main, listFragment);
				transaction.add(R.id.connect_layout_button, buttonFragment).commit();
			}

		@Override
		public void onAttach(Context context)
			{
				super.onAttach(context);
			}

		@Override
		public void onDetach()
			{
				super.onDetach();
			}

		public void onBackPressed()
			{

				// Check if detail view is active
				if (mConnectFragmentCached != null)
					{
						getActivity().setTitle(R.string.connect_title);
						// Return the cached ConnectFragment
						mFragmentManager.beginTransaction().replace(R.id.connect_layout_main, mConnectFragmentCached).commit();
						mConnectFragmentCached = null;
					}
			}

		@Override
		public void setMarkedCascade(MixCascade cascade)
			{
				mMarkedCascade = cascade;
			}

		@Override
		public void showDetailView(MixCascade cascade)
			{
				getActivity().setTitle(R.string.connectd_label_title);
				mDetailCascade = cascade;
				// Cache the ConnectFragment
				// Maybe use     fragmentTransaction.addToBackStack(DETAIL_TAG);
				mConnectFragmentCached = (ConnectListFragment) mFragmentManager.findFragmentById(R.id.connect_layout_main);
				String cascadeXML = XMLUtil.toString(cascade);
				ConnectDetailFragment connectDetailFragment = ConnectDetailFragment.newInstance(cascadeXML);
				mFragmentManager.beginTransaction().replace(R.id.connect_layout_main, connectDetailFragment).commit();
			}

		@Override
		public MixCascade getMarkedCascade()
			{
				return mMarkedCascade;
			}

		public MixCascade getTargetCascade()
			{
				// Check if we show the Connection overview
				Fragment activeFragment = mFragmentManager.findFragmentById(R.id.connect_layout_main);
				if (activeFragment != null && activeFragment instanceof ConnectListFragment)
					{
						return mMarkedCascade;
					}
				else if (activeFragment != null && activeFragment instanceof ConnectDetailFragment)
					{
						return mDetailCascade;
					}
				else
					{
						throw new RuntimeException("Unexpected activeFragment: " + activeFragment);
					}
			}

		private void showPasswordDialog()
			{
				final AlertDialog dialog = new AlertDialog.Builder(getContext()).create();
				dialog.setTitle("Password is not set yet");
				dialog.setMessage("Please enter the password for the connection.");

				final EditText input = new EditText(getContext());
				input.setInputType(InputType.TYPE_TEXT_VARIATION_PASSWORD);
				dialog.setView(input);

				dialog.setButton(AlertDialog.BUTTON_POSITIVE, "OK", new DialogInterface.OnClickListener()
					{
						@Override
						public void onClick(DialogInterface dialogInterface, int i)
							{
								String cascadeCredential = input.getText().toString();
								connectToCascade(cascadeCredential);
							}
					});
				dialog.setButton(AlertDialog.BUTTON_NEGATIVE, "Cancel", new DialogInterface.OnClickListener()
					{
						@Override
						public void onClick(DialogInterface dialogInterface, int i)
							{

							}
					});

				dialog.setCanceledOnTouchOutside(false);
				dialog.show();
			}

		@Override
		public void connectToCascade()
			{
				// TODO: 08.09.17 Display a progress bar which indicates that the connection to the cascade is pending.
				MixCascade newCascade = getTargetCascade();
				if (newCascade != null)
					{
						MixCascade chosenCascade = ((VPNConnectedActivity) getActivity()).getServiceInterface().getChosenCascade();
						if (chosenCascade != null && chosenCascade.compareMixIDs(newCascade))
							{
//								Toast.makeText(getContext(), getString(R.string.connectd_label_chosen), Toast.LENGTH_SHORT).show();
								Activity currentActivity = getActivity();
								if (currentActivity instanceof MainActivity)
									{
										((MainActivity) getActivity()).setFragment(MainActivity.FRAGMENTID_ANONYMITY);
									}
							}
						else if (newCascade.isAccessControlled())
							{
								showPasswordDialog(); //will internal call mListener.connectToCascade
							}
						else
							{
								connectToCascade("");
							}
					}
			}

		public void connectToCascade(String credential)
			{

				((VPNConnectedActivity) getActivity()).getServiceInterface().setChosenCascade(getTargetCascade(), credential);

				WAITING_FOR_CASCADE_CONNECTED = true;

				Activity currentActivity = getActivity();
				if (currentActivity instanceof MainActivity)
					{

						((MainActivity) getActivity()).enableVPNTunneling();
						((MainActivity) getActivity()).setFragment(MainActivity.FRAGMENTID_ANONYMITY);

					}
				else if (currentActivity instanceof TutorialActivity)
					{
						((TutorialActivity) currentActivity).cascadeChosen();
					}
				// I commented this, as the AndroidGUIInterface should check if the connection was successful
				// and then handle the result to the user. I.e. by redirecting to the AnonFragment or
				// by displaying an error message.

			}
	}
