package anonvpn.anon_next.android.ui.main;

import android.content.Context;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ProgressBar;
import android.widget.TextView;

import java.util.Hashtable;

import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import androidx.recyclerview.widget.DividerItemDecoration;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;
import anon.infoservice.MixCascade;
import anonvpn.anon_next.android.R;
import anonvpn.anon_next.android.ui.VPNConnectedActivity;

public class ConnectListFragment extends Fragment
	{

		private OnFragmentInteractionListener mListener;
		View viewConnect;
		ConnectRecyclerViewAdapter mConnectionListView;
		RecyclerView mCascadeListRecycler;
		ProgressBar pbar;
		TextView textView_error;
		GetCascadeListTask mCascadeListTask;

		private class GetCascadeListTask extends AsyncTask<Void, Void, Hashtable>
			{
				public boolean isRunning = false;

				@Override
				protected void onPreExecute()
					{
						super.onPreExecute();
						isRunning = true;
						pbar.setVisibility(ProgressBar.VISIBLE);
					}

				@Override
				protected Hashtable doInBackground(Void... params)
					{
						return ((VPNConnectedActivity) getActivity()).getServiceInterface().getCascadeList(true, true);
					}

				@Override
				protected void onPostExecute(Hashtable result)
					{
						// We might have closed this fragment while the task was requesting
						// the list of cascades
						if (!isCancelled())
							{
								pbar.setVisibility(ProgressBar.GONE);
								if (result != null)
									{
										updateCascadeListRecycler(result);
										// TODO: 19.09.17 Mark the current cascade.
									}
								else
									{            // this happens if we can not connect to the infoservice
										textView_error.setVisibility(TextView.VISIBLE);
									}
							}

						isRunning = false;
					}
			}

		public ConnectListFragment()
			{
				// Required empty public constructor
			}

		@Override
		public void onViewCreated(View view, @Nullable Bundle savedInstanceState)
			{
				super.onViewCreated(view, savedInstanceState);
				//
				// Prepare list of mix cascades
				//

				pbar = view.findViewById(R.id.connect_progressBar);
				textView_error = view.findViewById(R.id.connect_text_error);

				Context context = view.getContext();
				mCascadeListRecycler = (RecyclerView) view.findViewById(R.id.connect_list);
				mCascadeListRecycler.setLayoutManager(new LinearLayoutManager(context));

				mConnectionListView = new ConnectRecyclerViewAdapter(new Hashtable(), null, getActivity(), this);
				mCascadeListTask = new ConnectListFragment.GetCascadeListTask();
				mCascadeListTask.execute();

				mCascadeListRecycler.setAdapter(mConnectionListView);
			}

		public static ConnectListFragment newInstance()
			{
				ConnectListFragment fragment = new ConnectListFragment();
				return fragment;
			}

		@Override
		public void onCreate(Bundle savedInstanceState)
			{
				super.onCreate(savedInstanceState);
			}

		@Override
		public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState)
			{
				viewConnect = inflater.inflate(R.layout.fragment_connect_list, container, false);
				RecyclerView v = (RecyclerView) viewConnect.findViewById(R.id.connect_list);
				DividerItemDecoration dividerItemDecoration = new DividerItemDecoration(v.getContext(), LinearLayoutManager.VERTICAL);
				v.addItemDecoration(dividerItemDecoration);
				return viewConnect;
			}

//    public static float convertDpToPixel(float dp){
//        DisplayMetrics metrics = Resources.getSystem().getDisplayMetrics();
//        float px = dp * (metrics.densityDpi / 160f);
//        return Math.round(px);
//    }

		private void updateCascadeListRecycler(Hashtable cascadeList)
			{
				mConnectionListView = new ConnectRecyclerViewAdapter(cascadeList, ((VPNConnectedActivity) getActivity()).getServiceInterface().getChosenCascade(), getActivity(), this);
				mCascadeListRecycler.setAdapter(mConnectionListView);
			}

		public void setInteractionListener(OnFragmentInteractionListener listener)
			{
				mListener = listener;
			}

		@Override
		public void onPause()
			{
				super.onPause();
				if (mCascadeListTask.isRunning)
					{
						mCascadeListTask.cancel(true);
					}
			}

		public void showDetailView(MixCascade cascade)
			{
				mListener.showDetailView(cascade);
			}

		public void setMarkedCascade(MixCascade cascade)
			{
				mListener.setMarkedCascade(cascade);
			}

		/**
		 * This interface must be implemented by activities that contain this
		 * fragment to allow an interaction in this fragment to be communicated
		 * to the activity and potentially other fragments contained in that
		 * activity.
		 * <p>
		 * See the Android Training lesson <a href=
		 * "http://developer.android.com/training/basics/fragments/communicating.html"
		 * >Communicating with Other Fragments</a> for more information.
		 */
		public interface OnFragmentInteractionListener
			{
				void setMarkedCascade(MixCascade cascade);

				MixCascade getMarkedCascade();

				void showDetailView(MixCascade cascade);
			}
	}
