package anonvpn.anon_next.android.ui.main;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import java.util.Enumeration;
import java.util.Hashtable;

import androidx.recyclerview.widget.RecyclerView;
import anon.infoservice.MixCascade;
import anonvpn.anon_next.android.R;

//Der Adapter verbindet View und DataModel miteinander
class ConnectRecyclerViewAdapter extends RecyclerView.Adapter<ConnectRecyclerViewAdapter.ViewHolder>
	{
		private MixCascade[] m_Cascades;
		private Context _context;
		private int _selectedPosition = -1;
		private final MixCascade _chosenCascade;
		private ConnectListFragment _connectListFragment;

		ConnectRecyclerViewAdapter(Hashtable cascades, MixCascade chosenCascade, Context context, ConnectListFragment connectListFragment)
			{
				if (cascades == null)
					{
						m_Cascades = new MixCascade[0];
					}
				else
					{
						m_Cascades = new MixCascade[cascades.size()];
						Enumeration enumer = cascades.elements();
						int i = 0;
						while (enumer.hasMoreElements())
							{
								m_Cascades[i++] = (MixCascade) enumer.nextElement();
							}
					}
				_context = context;
				_chosenCascade = chosenCascade;
				_connectListFragment = connectListFragment;
			}

		@Override
		public ViewHolder onCreateViewHolder(ViewGroup parent, int viewType)
			{
				View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.item_connect, parent, false);
				return new ViewHolder(view);
			}

		@Override
		public void onBindViewHolder(final ViewHolder holder, final int position)
			{

				final MixCascade clicked_cascade = (MixCascade) m_Cascades[position];
				holder._item = clicked_cascade;
				if (clicked_cascade != null)
					{
						holder._tv_host.setText(clicked_cascade.getName());
						holder._tv_user.setText(Integer.toString(clicked_cascade.getCurrentStatus().getNrOfActiveUsers()));
						holder._tv_location.setText(clicked_cascade.getMixInfo(0).getServiceLocation().getCity());
						holder._tv_amoutMix.setText(Integer.toString(clicked_cascade.getNumberOfMixes()));
					}
				holder._ll_root.setOnClickListener(new View.OnClickListener()
					{
						@Override
						public void onClick(View v)
							{

								int previouslySelected = _selectedPosition;
								MixCascade connection = (MixCascade) m_Cascades[position];
								holder._ll_root.setBackgroundColor(_context.getResources().getColor(R.color.colorAccent));
								_selectedPosition = position;
								notifyItemChanged(previouslySelected);
								_connectListFragment.setMarkedCascade(clicked_cascade);
							}
					});
				holder._iv_details.setOnClickListener(new View.OnClickListener() {
					@Override
					public void onClick(View view) {
						_connectListFragment.showDetailView(clicked_cascade);
//						Fragment target_fragment = new ConnectDetailFragment();

//						// Create a new fragment transaction with this fragment in back stack
//						FragmentTransaction fragment_transaction = _connectListFragment.getFragmentManager().beginTransaction()
//								.add(R.id.fl_fragmentcontainer, target_fragment, "CONNECT_DETAIL_FRAGMENT")
//								.addToBackStack("CONNECT_FRAGMENT");
//
//						// Remove this fragment, else the views will overlap
//						Fragment current_fragment = _connectListFragment.getFragmentManager().findFragmentById(R.id.fl_fragmentcontainer);
//						if(current_fragment != null)
//							_connectListFragment.getFragmentManager().beginTransaction().remove(current_fragment).commit();
//
//						// Commit the transaction
//						fragment_transaction.commit();
//						Intent intent = new Intent(_connectListFragment.getContext(), ConnectDetailActivity.class);
////						intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_NEW_TASK);
////						intent.putExtra("FragmentID",-1);
//						try {
//							intent.putExtra("ClickedCascade.Object", XMLUtil.toString(clicked_cascade));
//						} catch (NullPointerException e) {
//							e.printStackTrace();
//						}
//						if (_connectListFragment.getActivity() instanceof MainActivity)
//						    intent.putExtra("Source", "MainActivity");
//              else if (_connectListFragment.getActivity() instanceof TutorialActivity)
//                intent.putExtra("Source", "TutorialActivity");
//              else
//                  throw new RuntimeException();
//						_connectListFragment.startActivityForResult(intent, 1);
					}
				});
				if (clicked_cascade.compareMixIDs(_chosenCascade)) {
					// TODO: 14.09.17 Mark previously chosen cascade for user
				}

				/*if (_chosenCascade != null && _chosenCascade.compareMixIDs(clicked_cascade))
					{
						holder._r_chosen.setChecked(true);
					}
				else
					{
						holder._r_chosen.setChecked(false);
					}*/

				if (position != _selectedPosition)
					{
						holder._ll_root.setBackgroundColor(_context.getResources().getColor(R.color.set_to_background));
					}
				else
					{
						holder._ll_root.setBackgroundColor(_context.getResources().getColor(R.color.colorAccent));
					}


			}

		@Override
		public int getItemCount()
			{
				if(m_Cascades==null)
					return 0;
				return m_Cascades.length;
			}

		public MixCascade getSelectedCascade()
			{
				if(m_Cascades==null)
					return null;
				int p=getSelectedPosition();
				if(p<0||p>=m_Cascades.length)
					return null;
				return m_Cascades[getSelectedPosition()];
			}

		class ViewHolder extends RecyclerView.ViewHolder
			{
				final View _view;
				final TextView _tv_host;
				final TextView _tv_user;
				final LinearLayout _ll_root;
				MixCascade _item;
//				final Button _b_select;
				//final RadioButton _r_chosen;
				final TextView _tv_amoutMix;
				final TextView _tv_location;
				final ImageView _iv_details;

				ViewHolder(View view)
					{
						super(view);
						_view = view;
						_tv_host = (TextView) view.findViewById(R.id.connect_tv_host);
						_tv_user = (TextView) view.findViewById(R.id.connect_tv_user);
						_ll_root = (LinearLayout) view.findViewById(R.id.connect_ll_root);
//						_b_select = (Button) view.findViewById(R.id.connect_b_select);
						//_r_chosen = (RadioButton) view.findViewById(R.id.connect_r_chosen);
						_tv_amoutMix = (TextView) view.findViewById(R.id.connect_tv_mix);
						_tv_location = (TextView) view.findViewById(R.id.connect_tv_location);
						_iv_details = view.findViewById(R.id.connect_iv_details);
					}
			}

		int getSelectedPosition()
			{
				return _selectedPosition;
			}
	}