package anonvpn.anon_next.core.networking.mocks;

import java.util.HashMap;

import anon.infoservice.MixCascade;
import anonvpn.anon_next.core.persistence.IConfig;

/**
 * Created by martin on 8/3/17.
 */

public class TestConfig implements IConfig {

    private HashMap<String, String> stringValues = new HashMap<>();
    private HashMap<String, Integer> intValues = new HashMap<>();
    private MixCascade mChosenCascade = null;
    private String mCredential = "TEST";

    @Override
    public void setString(String key, String data) {
        stringValues.put(key, data);
    }

    @Override
    public void setInt(String key, int data) {
        intValues.put(key, data);
    }

    @Override
    public String getString(String key, String defaultValue) {
        String result = defaultValue;
        if (stringValues.containsKey(key)) {
            result = stringValues.get(key);
        }
        return result;
    }

    @Override
    public int getInt(String key, int defaultValue) {
        int result = defaultValue;
        if (intValues.containsKey(key)) {
            result = intValues.get(key);
        }
        return result;
    }

    @Override
    public MixCascade getChosenMixCascade() {
        return mChosenCascade;
    }

    @Override
    public void setChosenMixCascade(MixCascade cascade) {
        mChosenCascade = cascade;
    }

    @Override
    public String getChosenCascadeCredential() {
        return mCredential;
    }

    @Override
    public void setChosenCascadeCredential(String credential) {
        mCredential = credential;
    }
}
