#!/bin/sh

#First: copy all source files neede because they are directly referenced by anonlib
filesToCopy=`grep -h -r "^import org.bouncycastle" src/main/java/ | sort -u | cut -d ' ' -f 2 | cut -d ';' -f 1 | sed 'y/./\//'`

originalBouncycastleDir=/cygdrive/c/data/jdk1.1.8/lcrypto-jdk11-167/src
anonBouncyCastleDir=/cygdrive/c/Users/sk13/Documents/projects/BouncyCastleLightForANON/src/main/java

echo "Copy needed files according to anonlib..."

for file in $filesToCopy
do
	file="${file}.java"
	echo $file
	targetpath=`dirname ${anonBouncyCastleDir}/${file}`
#	echo $targetpath
	mkdir -p $targetpath
	mv "${originalBouncycastleDir}/${file}" "${anonBouncyCastleDir}/${file}"
done

#Second copy all files needed by the copied bouncycastle files

for i in {1..5} #do it multiple times...
do
	echo "Copy dependencies..."

	filesToCopy=`grep -h -r "^import org.bouncycastle" ${anonBouncyCastleDir} | sort -u | cut -d ' ' -f 2 | cut -d ';' -f 1 | sed 'y/./\//'`


	#Copying files which are mentioned in the imports
	for file in $filesToCopy
	do
		file="${file}.java"
		echo $file
		targetpath=`dirname ${anonBouncyCastleDir}/${file}`
	#	echo $targetpath
		mkdir -p $targetpath
		mv "${originalBouncycastleDir}/${file}" "${anonBouncyCastleDir}/${file}"
	done
	
	#Files which are referenced from withn a Java file directly (i.e. begin part of the same package)
	origdir=$(pwd)
	cd ${anonBouncyCastleDir}
	files=`find -type f -name "*.java" -print`
	for file in $files
	do
		echo $file
		path=`dirname ${file}`
		classes=`grep -o -h -E "(new|extends|implements|instanceof) [a-zA-Z0-9]*" $file | cut -d ' ' -f 2 | sort -u`
		for class in $classes
		do
			fn="$path/${class}.java"
			echo $fn
			mv "${originalBouncycastleDir}/${fn}" "${anonBouncyCastleDir}/${fn}"
		done
	done	
	cd $origdir 	
done
	