package anon.anonudp.mixmessage;

import java.util.LinkedList;
import java.util.Hashtable;

import anon.anonudp.exception.NoCompleteMessages;

public class FragmentPool
	{
		private final Hashtable messages;
		private final LinkedList completeMessages;

		public FragmentPool()
			{
				this.messages = new Hashtable();
				this.completeMessages = new LinkedList();
			}

		public void addFragment(Fragment fragment)
			{
				Integer message_id = new Integer(fragment.getMessage_id());

				Message message;

				if (!this.messages.containsKey(message_id))
					{
						message = new Message(message_id.intValue());
						this.messages.put(message_id, message);
					}
				else
					{
						message = (Message) this.messages.get(message_id);
					}

				message.addFragment(fragment);

				if (message.isDone())
				{
					this.completeMessages.add(message);
					this.messages.remove(new Integer(message.getId()));
				}
			}

		/*
		 * Returns the number of completed messages available.
		 */
		int size()
			{
				return this.completeMessages.size();
			}

		public boolean hasNext()
			{
				return !this.completeMessages.isEmpty();
			}

		public byte[] next()
			{
				if (this.completeMessages.isEmpty())
					{
						throw new NoCompleteMessages();
					}
				else
					{
						Message message = (Message) this.completeMessages.removeFirst();
						return message.getPayload();
					}
			}
	}
