package anon.anonudp.mixmessage;

import java.security.SecureRandom;

import anon.anonudp.Constants;

public class Util {
    private static final SecureRandom random = new SecureRandom();

    static double log2(double num) {
        return (Math.log(num) / Math.log(2));
    }

    public static int bytesToUnsignedInt(byte[] integerInBytes)
    {
        int ret = 0;

        for (int i = 0; i < Math.min(integerInBytes.length, Constants.INT_SIZE); ++i)
        {
            ret += (integerInBytes[i] + 256) % 256 << (integerInBytes.length - 1 - i) * 8;
        }

        return ret;
    }

    public static byte[] unsignedIntToBytes(int data)
    {
    	byte[] result = new byte[4];

    	result[0] = (byte) ((data & 0xFF000000) >> 24);
    	result[1] = (byte) ((data & 0x00FF0000) >> 16);
    	result[2] = (byte) ((data & 0x0000FF00) >> 8);
    	result[3] = (byte) ((data & 0x000000FF) >> 0);

    	return result;
    }

    public static byte[] randomBytes(int numberOfBytes)
    {
        byte[] randomBytes = new byte[numberOfBytes];

        Util.random.nextBytes(randomBytes);

        return randomBytes;
    }

    public static byte[] copyOf(byte[] in, int size)
    {
        byte[] out = new byte[size];
        int l = Math.min(size, in.length);

        System.arraycopy(in, 0, out, 0,l);

        return out;
    }

    public static byte[] copyOfRange(byte[] in, int from, int to)
    {
    		if(in==null||from<0||to<from||from>=in.length)
    			return null;
    		if(to>in.length)
    			to=in.length;
        int size = to - from;
        byte[] out = new byte[size];
        System.arraycopy(in, from, out, 0,size);
        return out;
    }
}
