package anon.anonudp.mixmessage.crypto;

import anon.anonudp.Constants;

public class Counter {
    public static final int SIZE = Constants.INT_SIZE;

    private int currentValue;

    public Counter()
    {
        this(0);
    }

    public Counter(int startValue)
    {
        this.currentValue = startValue;
    }

    public Counter(byte[] prefix)
    {
        this(anon.anonudp.mixmessage.Util.bytesToUnsignedInt(prefix));
    }

    public int asInt()
    {
        return this.currentValue;
    }

    public void count()
    {
        ++this.currentValue;
    }

    public byte[] asBytes()
    {
        return anon.anonudp.mixmessage.Util.unsignedIntToBytes(this.currentValue);
    }

    public byte[] asIV()
    {
    		byte[] iv = new byte[EccGroup713.IV_LENGTH];

    		System.arraycopy(this.asBytes(), 0, iv, 0, SIZE);

        return iv;
    }

    public void asIV(byte[] iv)
    {   
    	iv[0]=(byte)((currentValue>>24)&0x00FF);	
    	iv[1]=(byte)((currentValue>>16)&0x00FF);	
    	iv[2]=(byte)((currentValue>>8)&0x00FF);	
    	iv[3]=(byte)((currentValue)&0x00FF);	
    }

    public boolean equals(Object obj) {
        if (obj instanceof Counter)
        {
            return this.currentValue == ((Counter) obj).asInt();
        }

        return super.equals(obj);
    }
}
