package anon.anonudp.mixmessage.crypto;

import java.util.ArrayList;
import java.util.Collections;

public class ReplayDetection
	{
		public static final int SIZE = 20;
		private static final Integer START_VALUE = new Integer(0);
		private static final int SMALLEST_ELEMENT = 0;
		private final ArrayList alreadySeen = new ArrayList(SIZE + 1);

		public ReplayDetection()
			{
				for (int i = 0; i < SIZE; ++i)
					alreadySeen.add(START_VALUE);
			}

/*		public int size()
			{
				return alreadySeen.size();
			}

*/		public boolean isValid(byte[] counterPrefix)
			{
				int packetID = new Counter(counterPrefix).asInt();

				return isValid(packetID);
			}

		public boolean isValid(int packetID)
			{
				if (alreadySeen.isEmpty())
					return false;

				boolean notAlreadySeen = !alreadySeen.contains(new Integer(packetID));
				boolean notTooSmall = !(new Integer(packetID + Integer.MIN_VALUE)
						.compareTo(new Integer(((Integer) alreadySeen.get(SMALLEST_ELEMENT)).intValue() + Integer.MIN_VALUE)) < 0);

				if (notAlreadySeen && notTooSmall)
					{
						alreadySeen.add(new Integer(packetID));
						Collections.sort(alreadySeen);
						alreadySeen.remove(SMALLEST_ELEMENT);
					}
				return notAlreadySeen && notTooSmall;
			}
	}
