package anon.anonudp.mixmessage.crypto;

import mybouncycastle.org.bouncycastle.crypto.engines.AESFastEngine;
import mybouncycastle.org.bouncycastle.crypto.modes.AEADBlockCipher;
import mybouncycastle.org.bouncycastle.crypto.modes.GCMBlockCipher;
import mybouncycastle.org.bouncycastle.crypto.params.AEADParameters;
import mybouncycastle.org.bouncycastle.crypto.params.KeyParameter;
import anon.anonudp.Constants;

public class Util {
    public static final int GCM_MAC_SIZE = 16;
    static final int IV_SIZE = 16;

    static AEADBlockCipher createGCM(byte[] symmetricKey, byte[] iv, boolean shouldEncrypt) {
        GCMBlockCipher cipher;

        cipher = new GCMBlockCipher(new AESFastEngine());

        AEADParameters keySpec = new AEADParameters(new KeyParameter(symmetricKey), Constants.BYTE_SIZE * GCM_MAC_SIZE, iv, null);

        cipher.init(shouldEncrypt, keySpec);

        return cipher;
    }
}
