package anon.anonudp.mixpacket;

import java.util.Arrays;

import anon.anonudp.mixmessage.Fragment;

public class DataPacket implements IPacket
	{
		public static final int SIZE = Fragment.DATA_OVERHEAD + Fragment.SIZE_DATA;
		private final int m_channelID;

		private final byte[] messageID;
		private final byte[] encryptedData;

		public DataPacket(int channelID, byte[] messageID, byte[] payload)
			{
				this.m_channelID = channelID;

				this.messageID = messageID;
				this.encryptedData = payload;
			}

		public byte[] getMessageID()
			{
				return this.messageID;
			}

		public int getChannelID()
			{
				return m_channelID;
			}

		public byte[] getData()
			{
				return this.encryptedData;
			}

		public byte getPacketType()
			{
				return IPacket.TYPE_DATA;
			}

		public boolean equals(Object obj)
			{
				if (obj instanceof DataPacket)
					return this.equals((DataPacket) obj);

				return super.equals(obj);
			}

		boolean equals(DataPacket otherPacket)
			{
				// todo can this be more performant?
				return Arrays.equals(this.encryptedData, otherPacket.getData());
			}
	}