package anon.anonudp.mixpacket;

import anon.anonudp.mixmessage.Util;
import anon.anonudp.mixmessage.crypto.EccGroup713;

public class InitResponse implements IPacket {
    private final int channelID;
    private final byte[] data;

    private final byte[] prefix;

    public InitResponse(int channelID, byte[] data)
    {
        this.channelID = channelID;
        this.data = data;

        this.prefix = Util.randomBytes(EccGroup713.SYMMETRIC_KEY_LENGTH);
    }
    public byte getPacketType() {
        return IPacket.TYPE_INIT_RESPONSE;
    }

    public byte[] getMessageID() {
        return this.prefix;
    }

    public int getChannelID() {
        return this.channelID;
    }

    public byte[] getData() {
        return this.data;
    }
}
