package anon.anonudp.mixpacket;

import anon.anonudp.mixmessage.crypto.PublicKey;

public class ProcessedInitPacket extends InitPacket
{
    private final byte[] requestChannelKey;
    private final byte[] responseChannelKey;

    public ProcessedInitPacket(int channelID, byte[] messageID, byte[] requestChannelKey, byte[] responseChannelKey, PublicKey element, byte[] processedChannelOnion, byte[] processedPayloadOnion)
    {
        super(channelID, messageID, element, processedChannelOnion, processedPayloadOnion);

        this.requestChannelKey = requestChannelKey;
        this.responseChannelKey = responseChannelKey;
    }

    public byte[] getRequestChannelKey() {
        return requestChannelKey;
    }

    public byte[] getResponseChannelKey() {
        return responseChannelKey;
    }

    public boolean equals(Object obj)
    {
        if (obj instanceof InitPacket)
            return ((InitPacket) obj).equals(this);

        return super.equals(obj);
    }
}