/*
 * Copyright (c) 2006, The JAP-Team
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *   - Redistributions of source code must retain the above copyright notice,
 *     this list of conditions and the following disclaimer.
 *
 *   - Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *   - Neither the name of the University of Technology Dresden, Germany nor
 *     the names of its contributors may be used to endorse or promote
 *     products derived from this software without specific prior written
 *     permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
package anon.client;

/**
 * @author Stefan Lieske
 */
final public class PacketProcessedEvent
	{

		public static final int CODE_DATA_PACKET_RECEIVED = 1;

		public static final int CODE_CONTROL_PACKET_RECEIVED = 2;

		public static final int CODE_DATA_PACKET_DISCARDED = 3;

		public static final int CODE_CONTROL_PACKET_DISCARDED = 4;

		public static final int CODE_DATA_PACKET_SENT = 5;

		public static final int CODE_CONTROL_PACKET_SENT = 6;

		public final static PacketProcessedEvent PPE_DATA_PACKET_RECEIVED=new PacketProcessedEvent(CODE_DATA_PACKET_RECEIVED);
		public final static PacketProcessedEvent PPE_CONTROL_PACKET_RECEIVED=new PacketProcessedEvent(CODE_CONTROL_PACKET_RECEIVED);
		public final static PacketProcessedEvent PPE_DATA_PACKET_DISCARDED =new PacketProcessedEvent(CODE_DATA_PACKET_DISCARDED );
		public final static PacketProcessedEvent PPE_CONTROL_PACKET_DISCARDED =new PacketProcessedEvent(CODE_CONTROL_PACKET_DISCARDED );
		public final static PacketProcessedEvent PPE_DATA_PACKET_SENT =new PacketProcessedEvent(CODE_DATA_PACKET_SENT );
		public final static PacketProcessedEvent PPE_CONTROL_PACKET_SENT =new PacketProcessedEvent(CODE_CONTROL_PACKET_SENT );
		
		private int m_code;

		private PacketProcessedEvent(int a_code)
			{
				m_code = a_code;
			}

		public int getCode()
			{
				return m_code;
			}

	}
