package anon.client.crypto;

public interface IDataChannelChipher
	{

		/**
		 * Set both keys to different values, if keys.length == 2 * KEY_SIZE, else
		 * set both keys to the same value.
		 * 
		 * @param keys
		 *          Array which contains key(s) (send and receive key)
		 * @return int
		 */
		int setEncryptionKeysAES(byte[] keys);

		/**
		 * Set both keys to different values, if keys.length == 2 * KEY_SIZE, else
		 * set both keys to the same value.
		 * 
		 * @param keys
		 *          Array which contains key(s) (send and receive key)
		 * @return int
		 */
		int setEncryptionKeysAES(byte[] keys, int offset, int keylen);

		/**
		 * Returns the currently used key(s) for encryption/decryption. If both keys
		 * are set, then an array of 32 byte is returned, otherwise an array of 16
		 * bytes is returned.
		 * 
		 * @return The current key(s) used for encryption/decryption or null, if no
		 *         key is set.
		 */
		byte[] getKeys();

		void encryptGCM1(byte[] from, int ifrom, byte[] to, int ito, int len) throws Exception;

		void decryptGCM2(byte[] from, int ifrom, byte[] to, int ito, int len) throws Exception;

	}