package anon.client.crypto;

public interface ISymCipher
	{
		/**
		 * Sets the AES encryption key to the value in the key buffer. Required
		 * length and error handling is implementation specific.
		 *
		 * @param key
		 * @return 0 if successful, -1 if an error occurred
		 */

		int setEncryptionKeyAES(byte[] key);

		/**
		 *
		 * @param key
		 *          byte[]
		 * @param offset
		 *          int
		 * @param len
		 *          int if len==16 --> only the key is set; if len==32 --> key and
		 *          IV is set
		 * @return int
		 */
		int setEncryptionKeyAES(byte[] key, int offset, int len);

		/**
		 * Set both keys to different value, if keys.length==2* KEY_SIZE, else set
		 * both keys to the same value
		 *
		 * @param keys
		 *          byte[]
		 * @return int
		 */
		int setEncryptionKeysAES(byte[] keys);

		/**
		 * Returns the currently used key(s) for encryption. If both keys are set,
		 * then an array of 32 byte is returned, otherwise an array of 16 bytes
		 * is.
		 *
		 * @return The current key(s) used for encryption or null, if no key is set.
		 */
		byte[] getKeys();

		void setIV2(byte[] buff);

		int encryptAES1(byte[] from, int ifrom, byte[] to, int ito, int len);

		int encryptAES2(byte[] buff);

	}