package anon.client.crypto;

import mybouncycastle.org.bouncycastle.crypto.params.AEADParameters;
import mybouncycastle.org.bouncycastle.crypto.params.KeyParameter;

/** AEADParams which do not clone the nonce for performance reasons*/
public class MyAEADParameters
extends AEADParameters
{
private byte[] m_Nonce;

/**
 * Base constructor.
 *
 * @param key key to be used by underlying cipher
 * @param macSize macSize in bits
 * @param nonce nonce to be used
 */
public MyAEADParameters(KeyParameter key, int macSize, byte[] nonce) 
{
   this(key, macSize, null, null);
}

/**
 * Base constructor.
 *
 * @param key key to be used by underlying cipher
 * @param macSize macSize in bits
 * @param nonce nonce to be used
 * @param associatedText initial associated text, if any
 */

public MyAEADParameters(KeyParameter key, int macSize, byte[] nonce, byte[] associatedText)
{
		super(key,macSize,null,associatedText);
		m_Nonce = nonce;
}

public byte[] getNonce()
{
    return m_Nonce;
}
}