/*
 Copyright (c) 2000, The JAP-Team
 All rights reserved.
 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:

 - Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.

 - Redistributions in binary form must reproduce the above copyright notice,
 this list of conditions and the following disclaimer in the documentation and/or
 other materials provided with the distribution.

 - Neither the name of the University of Technology Dresden, Germany nor the names of its contributors
 may be used to endorse or promote products derived from this software without specific
 prior written permission.


 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS'' AND ANY EXPRESS
 OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS
 BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
 IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE
 */
package anon.client.crypto;

final public class SymCipherNoEncryption implements ISymCipher
	{

		byte[] m_aesKeys;

		public SymCipherNoEncryption()
			{
			}

		synchronized public int setEncryptionKeyAES(byte[] key)
			{
				return setEncryptionKeyAES(key, 0, 16);
			}

		/**
		 * 
		 * @param key
		 *          byte[]
		 * @param offset
		 *          int
		 * @param len
		 *          int if len==16 --> only the key is set; if len==32 --> key and
		 *          IV is set
		 * @return int
		 */
		synchronized public int setEncryptionKeyAES(byte[] key, int offset, int len)
			{
				m_aesKeys = new byte[len];
				return 0;
			}

		/**
		 * Set both keys to different value, if keys.length==2* KEY_SIZe, else set
		 * both keys to the same value
		 * 
		 * @param keys
		 *          byte[]
		 * @return int
		 */
		synchronized public int setEncryptionKeysAES(byte[] keys)
			{
				m_aesKeys = new byte[keys.length];
				return 0;
			}

		/**
		 * Returns the currently used key(s) for encryption. If both keys are set,
		 * than an array of 32 byte is returned, otherwise an array of 16 bytes
		 * 
		 * @return The current key(s) used for encryption or null, if no key is set.
		 */
		public byte[] getKeys()
			{
				return m_aesKeys;
			}

		synchronized public void setIV2(byte[] buff)
			{
			}

		public int encryptAES1(byte[] from, int ifrom, byte[] to, int ito, int len)
			{
				System.arraycopy(from, ifrom, to, ito, len);
				return 0;
			}

		public int encryptAES2(byte[] buff)
			{
				return 0;
			}

	}
