package anon.crypto;

import java.math.BigInteger;

import mybouncycastle.org.bouncycastle.crypto.agreement.ECDHBasicAgreement;
import mybouncycastle.org.bouncycastle.crypto.params.ECPrivateKeyParameters;
import mybouncycastle.org.bouncycastle.crypto.params.ECPublicKeyParameters;

public class MyECDHAgreement
	{
		private ECDHBasicAgreement m_ecdhgAgreement=null;
		
		
		public MyECDHAgreement()
		{
			m_ecdhgAgreement=new ECDHBasicAgreement();
		}
		
		public void setPrivateKey(MyECPrivateKey privKey)
		{
			ECPrivateKeyParameters key=privKey.getPrivateParams();
			m_ecdhgAgreement.init(key);
		}
		
		public byte[] calculateShardSecret(MyECPublicKey pubKey)
		{
			ECPublicKeyParameters pub=pubKey.getPublicParams();
			BigInteger i=m_ecdhgAgreement.calculateAgreement(pub);
			byte[] b=i.toByteArray();
			int usableLength=b.length-1; // we do not use the most significant byte --- Note: we still have a bias here...
			int bi=1;
			byte[] result=new byte[usableLength];
			System.arraycopy(b,bi,result,0,usableLength);
			return result;	
		}

	}
