package anon.crypto;

import mybouncycastle.org.bouncycastle.crypto.digests.SHA3Digest;
import mybouncycastle.org.bouncycastle.crypto.generators.HKDFBytesGenerator;
import mybouncycastle.org.bouncycastle.crypto.params.HKDFParameters;

public class MyKDF
	{
		private HKDFBytesGenerator m_HKDFBytesGenerator;
		public MyKDF()
		{
			m_HKDFBytesGenerator=new HKDFBytesGenerator(new SHA3Digest());
		}
		
		/*** Generates a derived key out of the provided secret and some auxiliary information (salt, info).
		 * 
		 * @param secret the secret from which the key material should be derived
		 * @param salt an additional salt (may be null)
		 * @param info some additional info (may be null)
		 * @param len the number of bytes to be derived
		 * @return array of the derived bytes
		 */		
		public byte[] generateBytes(byte[] secret,byte[] salt, byte[] info,int len)
		{
			byte[] result=new byte[len];
			m_HKDFBytesGenerator.init(new HKDFParameters(secret,salt,info));
			m_HKDFBytesGenerator.generateBytes(result,0, len);
			return result;
		}

	}
