package anon.error;

import anon.ErrorCodes;
import anon.infoservice.MixCascade;
import anon.pay.PayAccount;

public class AccountEmptyException extends AnonServiceException 
{
	private static final long serialVersionUID = 1L;
	private PayAccount m_account;
	
	public AccountEmptyException(MixCascade a_service)
	{
		this(a_service, null);
	}
	
	public AccountEmptyException(MixCascade a_service, PayAccount a_account)
	{
		super(a_service, "Connection to service " + a_service + 
				" was closed because " +
				(a_account == null ? "no usable account is available." :
				"the account " + a_account.getAccountNumber() + " is empty."), 
				ErrorCodes.E_ACCOUNT_EMPTY);
		m_account = a_account;
	}
	
	public PayAccount getAccount()
	{
		return m_account;
	}
}
