package anon.error;

import anon.AnonServerDescription;
import anon.ErrorCodes;

public class AnonServiceException extends Exception
{
	private static final long serialVersionUID = 1L;
	
	private AnonServerDescription m_service;
	private int m_iErrorCode;
	
	public AnonServiceException(AnonServerDescription a_service, 
			String a_description, int a_iErrorCode)
	{
		super(a_description);
		m_service = a_service;
		m_iErrorCode = a_iErrorCode;
	}
	
	public AnonServiceException(AnonServerDescription a_service, String a_description)
	{
		this (a_service, a_description, ErrorCodes.E_UNKNOWN);
	}
	
	public final int getErrorCode()
	{
		return m_iErrorCode;
	}
	
	public final AnonServerDescription getService()
	{
		return m_service;
	}
}
