package anon.error;

import anon.infoservice.MixCascade;
import anon.infoservice.MixInfo;

public class NotRecoverableException extends AnonServiceException
	implements INotRecoverableException
{
	private static final long serialVersionUID = 1L;
	private int m_iMixIndex = -1;
	
	public NotRecoverableException(MixCascade a_service, 
			String a_description, int a_iErrorCode)
	
	{
		super(a_service, a_description, a_iErrorCode);
	}
	
	public NotRecoverableException(MixCascade a_service, 
			String a_description, int a_iErrorCode, int a_iMixIndex)
	
	{
		super(a_service, a_description, a_iErrorCode);
		m_iMixIndex = a_iMixIndex;
	}
	
	public MixCascade getMixCascade()
	{
		return (MixCascade)getService();
	}
	
	public int getMixIndex()
	{
		return m_iMixIndex;
	}
	
	public MixInfo getMixInfo()
	{
		if (m_iMixIndex >= 0 && getService() != null && 
			m_iMixIndex < getMixCascade().getNumberOfMixes())
		{
			return getMixCascade().getMixInfo(m_iMixIndex);
		}
		return null;
	}
}
