/*
 Copyright (c) 2000 - 2011, The JAP-Team
 All rights reserved.
 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:

  - Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.

  - Redistributions in binary form must reproduce the above copyright notice,
 this list of conditions and the following disclaimer in the documentation and/or
 other materials provided with the distribution.

  - Neither the name of the University of Technology Dresden, Germany nor the names of its contributors
 may be used to endorse or promote products derived from this software without specific
 prior written permission.


 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS'' AND ANY EXPRESS
 OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS
 BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
 IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE
 */
package anon.infoservice.externaldatabase;

import java.util.Vector;


public interface IEDBDatabase
	{
		/** Does a basic test, if this DB would work. Should be called prior to any other calls of this interface to ensure that they will work in principle**/
		public void testDB() throws Exception;

		/** Inserts some value of a given type with a given key into the database*/
		public void insert(String type, String key, String value) throws EDBException;

		/** Returns all types stored in this database*/
		public Vector getAllTypes() throws EDBException;

		/** Returns all values of a given type stored in this database*/
		public Vector getAllValuesOfType(String type) throws EDBException;

		/** Removes a type from this database, i.e. all values of the given type and the type itself will be deleted*/
		public void removeType(String type) throws EDBException;

		/** Removes a value with a given type and key form this database*/
		public void remove(String type, String key) throws EDBException;

		/** Makes some database cleanups to save space*/
		public void doVacuum() throws EDBException;

	}
