package anon.pay.xml;

import anon.AnonServerDescription;
import anon.error.INotRecoverableException;
import anon.pay.PayAccount;

public class NotRecoverableXMLError extends XMLErrorMessage 
	implements INotRecoverableException
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private XMLErrorMessage m_source;
	
	public NotRecoverableXMLError(int errorCode, String message, PayAccount a_account, 
			AnonServerDescription a_service)
	{
		super(errorCode, message, a_account, a_service);
		m_source = this;
	}
	
	public NotRecoverableXMLError(XMLErrorMessage a_errorMessage)
	{
		super(a_errorMessage.getXmlErrorCode(), a_errorMessage.getMessage(), 
				a_errorMessage.getAccount(), a_errorMessage.getService());
		m_source = a_errorMessage;
	}
	
	public XMLErrorMessage getSource()
	{
		return m_source;
	}
	
}
