/*
Copyright (c) 2008 The JAP-Team, JonDos GmbH

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation and/or
       other materials provided with the distribution.
    * Neither the name of the University of Technology Dresden, Germany, nor the name of
       the JonDos GmbH, nor the names of their contributors may be used to endorse or
       promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package anon.proxy;

public abstract class AbstractHTTPConnectionListener 
{
	private int m_priority;
	public AbstractHTTPConnectionListener(int a_priority)
	{
		m_priority = a_priority;
	}
	
	public final int getPriority()
	{
		return m_priority;
	}
	
	public boolean isBlockable()
	{
		return true;
	}
	
	public abstract void requestHeadersReceived(HTTPConnectionEvent event);
	
	public abstract void responseHeadersReceived(HTTPConnectionEvent event);
	
	public abstract void upstreamContentBytesReceived(HTTPConnectionEvent event);
	
	public abstract void downstreamContentBytesReceived(HTTPConnectionEvent event);
	
	public final boolean equals(Object a_object)
	{
		if (a_object == null)
		{
			return false;
		}
		if (a_object.getClass() == getClass())
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	public final int hashCode()
	{
		return getClass().getName().hashCode();
	}
}
