/*
 Copyright (c) 2000, The JAP-Team
 All rights reserved.
 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:

 - Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer.

 - Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation and/or
  other materials provided with the distribution.

 - Neither the name of the University of Technology Dresden, Germany nor the names of its contributors
   may be used to endorse or promote products derived from this software without specific
  prior written permission.


 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS'' AND ANY EXPRESS
 OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS
 BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
 IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE
 */
package anon.proxy;

import anon.proxy.HTTPProxyCallback.HTTPConnectionHeader;

public final class JonDonymXHeaders extends AbstractHTTPConnectionListener 
{
	private final static String HTTP_X_JONDONYM_PROXY_KEEP_ALIVE = "X-JonDonym-Proxy-Connection";
	private final static String HTTP_X_JONDONYM_DISTRIBUTION = "X-JonDonym-Distribution";
	public final static String HTTP_X_JONDONYM_PREMIUM = "X-JonDonym-Premium";
	
	public JonDonymXHeaders(int a_priority)
	{
		super(a_priority);
	}
	
	public void handleRequest(HTTPConnectionEvent event)
	{
	}
	
	public boolean isBlockable()
	{
		return false;
	}

	public void downstreamContentBytesReceived(HTTPConnectionEvent event) 
	{
	}
	
	public void requestHeadersReceived(HTTPConnectionEvent event) 
	{
		if (event == null)
		{
			return;
		}

		HTTPConnectionHeader connHeader = event.getConnectionHeader();
		
		
		boolean bProxyKeepAlive = false;
		String[] checkHeader;
		
		/*
		checkHeader = connHeader.getRequestHeader(HTTPProxyCallback.HTTP_CONNECTION);
		if (checkHeader != null && checkHeader.length >= 1 && 
			checkHeader[0].toLowerCase().indexOf(HTTPProxyCallback.HTTP_KEEP_ALIVE.toLowerCase()) >= 0)
		{
			bProxyKeepAlive = true;
		}*/
		
		/*
		checkHeader = connHeader.getRequestHeader(HTTPProxyCallback.HTTP_PROXY_CONNECTION);
		if (checkHeader != null && checkHeader.length >= 1 && 
			checkHeader[0].toLowerCase().indexOf(HTTPProxyCallback.HTTP_KEEP_ALIVE.toLowerCase()) >= 0)
		{
			// This is a strong indication that this browser supports proxy-connection:keep-alive!
			bProxyKeepAlive = true;
		}
		*/
		
		/*
		if (HTTPProxyCallback.isJonDosDomain(connHeader))
		{
			if (PayAccountsFile.getInstance().isNewUser())
			{
				connHeader.setRequestHeader(HTTP_X_JONDONYM_PREMIUM, "false");
			}
			else
			{
				connHeader.setRequestHeader(HTTP_X_JONDONYM_PREMIUM, "true");
			}
		}
		*/
		
		if (HTTPProxyCallback.isAnonymityTestDomain(connHeader))
		{
			// Tell the test page that this is a JonDonym service, and its distribution.
			connHeader.setRequestHeader(HTTP_X_JONDONYM_DISTRIBUTION, 
					"" + event.getAnonRequest().getAnonymityDistribution());
			
			if (bProxyKeepAlive || event.getAnonRequest().isProxyKeepAliveEnabled())
			{
				/*
				 * The client seems to have proxy-keep-alive activated!
				 */
				connHeader.setRequestHeader(HTTP_X_JONDONYM_PROXY_KEEP_ALIVE, 
						HTTPProxyCallback.HTTP_ATTR_KEEP_ALIVE);
			}
			else
			{
				connHeader.setRequestHeader(HTTP_X_JONDONYM_PROXY_KEEP_ALIVE, 
						HTTPProxyCallback.HTTP_ATTR_CLOSE);
			}
		}
		
	}

	public void responseHeadersReceived(HTTPConnectionEvent event) 
	{
	}

	public void upstreamContentBytesReceived(HTTPConnectionEvent event) 
	{
	}
}
