package anon.anonudp.client.test;

import anon.AnonChannel;
import anon.anonudp.UDPMultiplexer;
import anon.anonudp.client.AnonPureUDPChannel;
import anon.client.AnonClient;
import anon.client.AnonUDPChannel;
import anon.client.DummyTrafficControlChannel;
import anon.client.IAnonUDPChannel;
import anon.crypto.SignatureVerifier;
import anon.infoservice.MixCascade;
import anon.infoservice.SimpleMixCascadeContainer;
import junit.framework.TestCase;
import logging.LogHolder;
import logging.LogLevel;
import logging.LogType;
import logging.SystemErrLog;

public class AnonPureUDPChannelWithoutAnon extends TestCase
	{

		public void testChannel()
			{
				try
					{
						String mixHost = "172.20.46.105";
						int mixPort = 6544;
						SystemErrLog mLog = new SystemErrLog();
						mLog.setLogLevel(LogLevel.DEBUG);
						mLog.setLogType(LogType.ALL);
						LogHolder.setDetailLevel(LogHolder.DETAIL_LEVEL_HIGHEST);
						LogHolder.setLogInstance(mLog);
						MixCascade mixCascade = new MixCascade(mixHost, mixPort);
						mixCascade.setAccessControlPreSharedSecret("anonvpnrules");

						// insecure, of course - but necessary for this simple manually added mix-cascade
						SignatureVerifier.getInstance().setCheckSignatures(false);
						AnonClient anon = new AnonClient(null); //create AN.ON client
						//initialize the client --> establish the connection
						anon.initialize(mixCascade, new SimpleMixCascadeContainer(mixCascade), null, true);
						anon.setDummyTraffic(DummyTrafficControlChannel.DT_DISABLE);

						IAnonUDPChannel channel = (IAnonUDPChannel) anon.createChannel(AnonChannel.UDP_OVER_UDP);

						channel.setDestination("10.0.0.1", 65478);
						//channel.setSourcePort(1234);

						int packetSize = 650;

						byte[] sent = new byte[packetSize];
						byte[] received = new byte[packetSize];

						// setup done

						for (int i = 0; i < sent.length; i++)
							sent[i] = (byte) (i & 0x00FF);

						for (int j = 0; j < 50; j++)
							{
								channel.writePacket(sent);
								channel.readPacket(received, 0, received.length);
								System.out.println("Received UDP Packet..");
								for (int i = 0; i < received.length; i++)
									assertEquals(received[i], (byte) (i & 0x00FF));
							}
						channel.close();

						/*			for (int z = 0; z < 70; z++)
										{
											System.out.println("Create UDP channel: " + z);
											channel =  (IAnonUDPChannel)anon.createChannel(AnonChannel.UDP_OVER_UDP);
						
											channel.setDestination(mixHost, 1234);
											//channel.setSourcePort(1234);
						
											channel.writePacket(sent);
											channel.close();
										}*/
					}
				catch (Exception e)
					{
						e.printStackTrace();
						fail();
						return;
					}
			}
	}
