package anon.anonudp.mixmessage.crypto;

import anon.anonudp.Constants;
import junit.framework.TestCase;

public class ReplayDetectionTest extends TestCase
	{
		
		int getFragmentID(byte[] fragment)
		{
			int 			current_offset=0;
    int message_id = fragment[current_offset];
    message_id <<= Constants.BYTE_SIZE;

    ++current_offset;

    message_id |= (fragment[current_offset]&0x00FF);
    message_id >>= 2;
    return message_id;
		}
		
		public void testMFragmentID()
		{
			byte[] b=new byte[2];
			for(int i=31;i<0x3F;i++)
				{
					int k=i<<2;
					b[0]=(byte)((k>>8)&0xFF);
					b[1]=(byte)((k)&0xFF);
					int j=getFragmentID(b);
					assertEquals(i,j);
				}
		}
		
		public void testPerformance()
		{
			
			
			
			ReplayDetection rp=new ReplayDetection();
			MyReplayDetection mrp=new MyReplayDetection();

			assertTrue(mrp.isValid(4));			
			assertFalse(mrp.isValid(4));
			assertTrue(mrp.isValid(63));
			assertFalse(mrp.isValid(4));
			assertFalse(mrp.isValid(63));
			
			int id=1;
			long numRuns = 100000000;
			long startTime = System.currentTimeMillis();
			for (int k = 0; k < numRuns; k++)
				{
					rp.isValid(id++);
				}
			long endTime = System.currentTimeMillis();
			int time = (int) (endTime - startTime);
			if(time==0)
				time =1;
			long x = (numRuns * 1000) / time;
			System.out.println(
					"Original method: Finished " + numRuns + " Replay detection processings in " + time + " ms -- " + x + " pro second");
			 startTime = System.currentTimeMillis();
			for (int k = 0; k < numRuns; k++)
				{
					mrp.isValid(id++);
				}
			 endTime = System.currentTimeMillis();
			 time = (int) (endTime - startTime);
			 x = (numRuns * 1000) / time;
			System.out.println(
					"Optimised method: Finished " + numRuns + " Replay detection processings in " + time + " ms -- " + x + " pro second");
		}

	}
