package anon.client.test;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.ConnectException;
import java.net.InetAddress;
import java.net.Socket;

import HTTPClient.HTTPClientSocketFactory;
import anon.AnonChannel;
import anon.client.AnonClient;
import anon.client.AnonTCPChannel;
import anon.client.AnonUDPChannel;
import anon.crypto.SignatureVerifier;
import anon.infoservice.MixCascade;
import anon.infoservice.SimpleMixCascadeContainer;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import logging.LogHolder;
import logging.LogLevel;
import logging.LogType;
import logging.SystemErrLog;

public class AnonUDPChannelTest extends TestCase
	{
		
			
		protected void runTest()
			{
				try{
				AnonClient  anon=new AnonClient(null); //create AN.ON client
				SystemErrLog mLog = new SystemErrLog();
				mLog.setLogLevel(LogLevel.DEBUG);
				mLog.setLogType(LogType.ALL);
				LogHolder.setDetailLevel(LogHolder.DETAIL_LEVEL_HIGHEST);
				LogHolder.setLogInstance(mLog);
				//--> set to your cascade here!!
				MixCascade mixCascade=new MixCascade(null, null, "141.76.46.140", 56544); //manually select mix cascade
				mixCascade.setAccessControlPreSharedSecret("anonvpnrules");
				SignatureVerifier.getInstance().setCheckSignatures(false); //insecure, of course - but necessary for this simple manually added mix-cascade

				//initialize the client --> establish the connection
				anon.initialize(mixCascade, new SimpleMixCascadeContainer(mixCascade), null, true);
				
				doDNSTest(anon);
				
				//create a communication channel (like a connected socket)
			//	AnonUDPChannel c=(AnonUDPChannel)anon.createChannel(AnonChannel.UDP_OVER_TCP);	
		//		byte[] testPacket=new byte[650];
				/*c.setDestination("10.0.0.1", 53);
				c.setSourcePort(1234);
				

				
				for(int i=0;i<testPacket.length;i++)
					testPacket[i]=(byte)(i&0x00FF);
				c.writePacket(testPacket);
				for(int i=0;i<testPacket.length;i++)
					testPacket[i]=0;
				c.readPacket(testPacket, 0,testPacket.length);
				for(int i=0;i<testPacket.length;i++)
					assertEquals(testPacket[i],(byte)(i&0x00FF));
				c.close();
				*/
			/*	for(int z=0;z<70;z++)
					{
						System.out.println("Create UDP channel: "+z);
						c=(AnonUDPChannel)anon.createChannel(AnonChannel.UDP_OVER_TCP);	
						
						c.setDestination("127.0.0.1", 1234);
						c.setSourcePort(1234);
						testPacket=new byte[650];
						for(int i=0;i<testPacket.length;i++)
							testPacket[i]=(byte)(i&0x00FF);
						c.writePacket(testPacket);
						c.close();
					}
				*/
	/*			c=(AnonUDPChannel)anon.createChannel(AnonChannel.UDP_OVER_TCP);	
				
				c.setDestination("10.0.0.1", 1234);
				c.setSourcePort(1234);
				

	testPacket=new byte[650];
				for(int i=0;i<testPacket.length;i++)
					testPacket[i]=(byte)(i&0x00FF);
				c.writePacket(testPacket);
				for(int i=0;i<testPacket.length;i++)
					testPacket[i]=0;
				c.readPacket(testPacket, 0,testPacket.length);
				for(int i=0;i<testPacket.length;i++)
					assertEquals(testPacket[i],(byte)(i&0x00FF));
				c.close();
			*/	}
				
				catch(Exception e)
					{
						e.printStackTrace();
						assertEquals(true,false);
						return;
					}			
					
			}
	
		
		private void doDNSTest(AnonClient anon)
		{
			AnonUDPChannel c;
			try
				{
					c = (AnonUDPChannel)anon.createChannel(AnonChannel.UDP_OVER_TCP);
					c.setDestination("10.0.0.1", 53);
					c.setSourcePort(53);
					//DNS request for www.google.com
					byte[] dnsRequestPacket= {0x24, 0x1a, 0x01, 0x00, 
							0x00, 0x01, 0x00, 0x30, 0x00, 0x00, 0x00, 0x00, 
							0x00, 0x00, 0x03, 0x77, 0x77, 0x77, 0x06, 
							0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x00, 0x40, 0x65, 
							0x03, 0x63, 0x6f, 0x6d, 0x00, 0x00, 0x01, 0x00, 0x01};
					byte[] dnsResponsePacket=new byte[1000];
					c.writePacket(dnsRequestPacket);
					int respLen=c.readPacket(dnsResponsePacket, 0,dnsResponsePacket.length);
					System.out.println("DNS Response len: "+respLen);
					System.out.println("DNS Response Identification: "+((dnsResponsePacket[0]<<8|dnsResponsePacket[1])&0x00FFFF));
					int flags=((dnsResponsePacket[2]<<8|dnsResponsePacket[3])&0x00FFFF);
					System.out.println("DNS Response Flags: "+flags);
					int QR=(flags>>15)&0x1;
					System.out.println("DNS Response Flags - QR: "+QR);
					int RCODE=(flags>>12)&0x015;
					System.out.println("DNS Response Flags - Response Code: "+RCODE);
					
					System.out.println("DNS Response Number of Questions: "+((dnsResponsePacket[4]<<8|dnsResponsePacket[5])&0x00FFFF));
					System.out.println("DNS Response Number of Answers: "+((dnsResponsePacket[6]<<8|dnsResponsePacket[7])&0x00FFFF));
					System.out.println("DNS Response Number of authority resource records: "+((dnsResponsePacket[8]<<8|dnsResponsePacket[9])&0x00FFFF));
					System.out.println("DNS Response Number of Number of additional RRs: "+((dnsResponsePacket[10]<<8|dnsResponsePacket[11])&0x00FFFF));
					
					
					System.out.println(new String(dnsResponsePacket,0,respLen));
					c.close();
				}
			catch (Exception e)
				{
					// TODO Auto-generated catch block
					e.printStackTrace();
					assertFalse(true);
				}
			
		}
		
		private static Test[] createAllTests()
			{
				Test[] allTests = new Test[1];
				allTests[0]=new AnonUDPChannelTest();
				return allTests;
			}

		public static Test suite()
			{
				Test[] allTests = createAllTests();
				TestSuite suite = new TestSuite(AnonUDPChannelTest.class.getName());
				for (int i = 0; i < allTests.length; i++) 
				{
					suite.addTest(allTests[i]);
				}
				return suite;
			}
	}
