package anon.crypto;

import java.security.SecureRandom;

import mybouncycastle.org.bouncycastle.asn1.teletrust.TeleTrusTObjectIdentifiers;

import anon.util.Util;
import junit.framework.TestCase;

public class MyECDHAgreementTest extends TestCase
	{

		public void testCalculateShardSecret()
			{
				MyECDHAgreement a1=new MyECDHAgreement();
				MyECDHAgreement a2=new MyECDHAgreement();
				SecureRandom s=new SecureRandom();
				ECKeyPair p1=ECKeyPair.getInstance(TeleTrusTObjectIdentifiers.brainpoolP256r1, s);
				ECKeyPair p2=ECKeyPair.getInstance(TeleTrusTObjectIdentifiers.brainpoolP256r1, s);
				a1.setPrivateKey((MyECPrivateKey)p1.getPrivate());
				byte[] b1=a1.calculateShardSecret((MyECPublicKey)p2.getPublic());
				a2.setPrivateKey((MyECPrivateKey)p2.getPrivate());
				byte[] b2=a2.calculateShardSecret((MyECPublicKey)p1.getPublic());
				assertTrue("ECDHKeyAgreement - calculated shared secrets do not match!",Util.arraysEqual(b1, b2));
		}

	}
