package anon.crypto.test;


import anon.client.crypto.DataChannelCipher;
import anon.client.crypto.DataChannelCipherSDK;
import anon.util.Util;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

public class DataChannelCipherTest extends TestCase
	{
		
		
		protected void runTest()
			{
				try{
					
					
					byte[]key=new byte[32];
					byte[]key2=new byte[32];
					DataChannelCipherSDK c=new DataChannelCipherSDK();
					DataChannelCipher c2=new DataChannelCipher();
					
					byte[]inBuff=new byte[1700];
					byte[]outBuff=new byte[1700];
					byte[]outBuff2=new byte[1700];
					
					int s=1600;
					c.setEncryptionKeysAES(key);
					c2.setEncryptionKeysAES(key2);

					c.encryptGCM1(inBuff, 0, outBuff, 0, s);
					c2.encryptGCM1(inBuff, 0, outBuff2, 0,s);
					
					assertTrue(Util.arraysEqual(outBuff,0, outBuff2,0,s));
	
					s=989;
					c=new DataChannelCipherSDK();
					c2=new DataChannelCipher();
					
					c.setEncryptionKeysAES(key);
					c2.setEncryptionKeysAES(key2);
					
					c.encryptGCM1(inBuff, 0, outBuff, 0, s);
					c2.encryptGCM1(inBuff, 0, outBuff2, 0,s);
					
					assertTrue(Util.arraysEqual(outBuff,0, outBuff2,0,s));
	
					c=new DataChannelCipherSDK();
					c2=new DataChannelCipher();
					c.setEncryptionKeysAES(key);
					c2.setEncryptionKeysAES(key2);
					
					inBuff=new byte[s+16];
					c.encryptGCM1(inBuff,0,outBuff2,0,s);
					outBuff=new byte[s+16];
					c2.encryptGCM1(outBuff,0,outBuff,0,s);
					
					assertTrue(Util.arraysEqual(outBuff2,0, outBuff,0,s));

					c=new DataChannelCipherSDK();
					c2=new DataChannelCipher();
					c.setEncryptionKeysAES(key);
					c2.setEncryptionKeysAES(key2);
					
					/*c.decryptGCM2(outBuff2,0,inBuff,0,s+16);
					byte[]outBuff3=new byte[1700];

					c2.decryptGCM2(outBuff,0,outBuff3,0,s);

					assertTrue(Util.arraysEqual(outBuff2,0, outBuff3,0,s));
					inBuff=new byte[s];
					assertTrue(Util.arraysEqual(inBuff,0, outBuff3,0,s));
*/
					
					c=new DataChannelCipherSDK();
					c2=new DataChannelCipher();
					c.setEncryptionKeysAES(key);
					c2.setEncryptionKeysAES(key2);
					
					int iter = 1000000;
					s=989;
					long start = System.currentTimeMillis();
					for (int i = 0; i < iter; i++)
						{
							c.encryptGCM1(inBuff,0,outBuff,0,s);
						}
					long end = System.currentTimeMillis();
					System.out.println("SDK encryption takes: " + (end - start) + " ms");

				
					start = System.currentTimeMillis();
					for (int i = 0; i < iter; i++)
						{
							c2.encryptGCM1(inBuff,0,outBuff2,0,s);
						}
					end = System.currentTimeMillis();
					System.out.println("BouncyCastle encryption takes: " + (end - start) + " ms");
					
					
				}
				catch(Exception e)
					{
						e.printStackTrace();
						assertEquals(true,false);
						return;
					}
				assertEquals(true,true);

			
			}
	
		private static Test[] createAllTests()
			{
				Test[] allTests = new Test[1];
				allTests[0]=new DataChannelCipherTest();
				return allTests;
			}

		public static Test suite()
			{
				Test[] allTests = createAllTests();
				TestSuite suite = new TestSuite(DataChannelCipherTest.class.getName());
				for (int i = 0; i < allTests.length; i++) 
				{
					suite.addTest(allTests[i]);
				}
				return suite;
			}
	}