package anon.crypto.test;


import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;

import anon.client.crypto.ISymCipher;
import anon.client.crypto.SymCipher;
import anon.client.crypto.SymCipherCTR;
import anon.client.crypto.SymCipherMultithreadedCTR;
import anon.crypto.ByteSignature;
import anon.util.Util;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

public class SymCipherTest extends TestCase
	{
		
		
		protected void runTest()
			{
				try{
					
					SymCipher co=new SymCipher();
					byte[] ko=new byte[16];
					co.setEncryptionKeyAES(ko);
					byte[] ino=new byte[16];
					byte[] outo=new byte[16]; 
					co.encryptAES1(ino, 0, outo, 0, 16);
					System.out.println(ByteSignature.toHexString(outo));
					co.encryptAES1(ino, 0, outo, 0, 16);
					System.out.println(ByteSignature.toHexString(outo));
					co.encryptAES1(ino, 0, outo, 0, 16);
					System.out.println(ByteSignature.toHexString(outo));
					
					
					
					SymCipherCTR c3=new SymCipherCTR();
					byte[]k=new byte[16];
					c3.setEncryptionKeyAES(k);
					byte[]iv=new byte[16];
//					for(int o=0;o<16;o++)
//						iv[o]=(byte) 0xFF;
					c3.setIV2(iv);
					byte[]b=new byte[989];
					
					c3.encryptAES1(b,0,b,0,b.length);
					for(int o=0;o<16;o++)
						iv[o]=(byte) 0x00;
					c3.setIV2(iv);
					c3.encryptAES2(b)	;
					
					
					byte[]key=new byte[32];
					SymCipherCTR c=new SymCipherCTR();
					ISymCipher c2=new SymCipher();
					
					byte[]inBuff=new byte[1600];
					byte[]outBuff=new byte[1600];
					byte[]outBuff2=new byte[1600];
					/*
					int s=1600;
					
					c.setEncryptionKeyAES(key);
					c2.setEncryptionKeyAES(key);
					
					c.encryptAES1(inBuff, 0, outBuff, 0, s);
					c2.encryptAES1(inBuff, 0, outBuff2, 0,s);
					
					assertTrue(Util.arraysEqual(outBuff,0, outBuff2,0,s));
	
					s=989;
					
					c.setEncryptionKeyAES(key);
					c2.setEncryptionKeyAES(key);
					
					c.encryptAES1(inBuff, 0, outBuff, 0, s);
					c2.encryptAES1(inBuff, 0, outBuff2, 0,s);
					
					assertTrue(Util.arraysEqual(outBuff,0, outBuff2,0,s));
	
					c.setEncryptionKeyAES(key);
					c2.setEncryptionKeyAES(key);
					
					inBuff=new byte[s];
					c.encryptAES2(inBuff);
					outBuff=new byte[s];
					c2.encryptAES2(outBuff);
					
					assertTrue(Util.arraysEqual(inBuff,0, outBuff,0,s));
	
					c.setEncryptionKeyAES(key);
					c2.setEncryptionKeyAES(key);
				
					int iter = 10000000;
					s=989;
					long start = System.currentTimeMillis();
					for (int i = 0; i < iter; i++)
						{
							c.encryptAES1(inBuff,0,outBuff,0,s);
						}
					long end = System.currentTimeMillis();
					System.out.println("SDK encryption takes: " + (end - start) + " ms");

				
					start = System.currentTimeMillis();
					for (int i = 0; i < iter; i++)
						{
							c2.encryptAES1(inBuff,0,outBuff2,0,s);
						}
					end = System.currentTimeMillis();
					System.out.println("BouncyCastle encryption takes: " + (end - start) + " ms");
			*/		
					SymCipherCTR c4=new SymCipherCTR();
					k=new byte[16];
					c4.setEncryptionKeyAES(k);
					inBuff=new byte[1600];
					outBuff=new byte[1600];
					outBuff2=new byte[1600];
					c4.encryptAES1(inBuff, 0, outBuff, 0, 1600);
					for(int i=0;i<inBuff.length;i++)
						{
							inBuff[i]=42;
						}
					c4.setEncryptionKeyAES(k);
					long l1=System.currentTimeMillis();
					//for (int i = 0; i < 1000000; i++)
						c4.encryptAES1(inBuff, 0, outBuff2, 0, 1600);
					long l2=System.currentTimeMillis();
					System.out.println("Systtem CTR mode encryption takes: " + (l2 - l1) + " ms");
					for(int i=0;i<outBuff.length;i++)
						{
							outBuff[i]=(byte)(inBuff[i]^outBuff[i]);
						}
					
					Cipher ecb=Cipher.getInstance("AES/ECB/NoPadding");
					ecb.init(Cipher.ENCRYPT_MODE, new SecretKeySpec(k, "AES"));
					l1=System.currentTimeMillis();
					//for (int i = 0; i < 100000000; i++)
						c4.encryptAES1(inBuff, 0, outBuff2, 0, 1600);
					l2=System.currentTimeMillis();
					System.out.println("Systtem ECB mode encryption takes: " + (l2 - l1) + " ms");
					l1=System.currentTimeMillis();
					/*for (int i = 0; i < 1000000; i++)
						{
							c4.encryptAES1(inBuff, 0, outBuff2, 0, 1600);
							for(int j=0;j<outBuff.length;j++)
								{
									outBuff[j]=(byte)(inBuff[j]^outBuff[j]);
								}
						}*/
					l2=System.currentTimeMillis();
					System.out.println("Systtem ECB mode + CTR XOR  takes: " + (l2 - l1) + " ms");
					
					SymCipherMultithreadedCTR c5=new SymCipherMultithreadedCTR();
					c5.setEncryptionKeyAES(k);
					l1=System.currentTimeMillis();
					for (int i = 0; i < 10000000; i++)
						c5.encryptAES1(inBuff, 0, outBuff, 0, 1600);
					l2=System.currentTimeMillis();
					System.out.println("System Multithreaded CTR mode encryption takes: " + (l2 - l1) + " ms");
					assertTrue(Util.arraysEqual(outBuff,0, outBuff2,0,outBuff.length));
					
				}
				catch(Exception e)
					{
						e.printStackTrace();
						assertEquals(true,false);
						return;
					}
				assertEquals(true,true);

			
			}
	
		
		
		private static Test[] createAllTests()
			{
				Test[] allTests = new Test[1];
				allTests[0]=new SymCipherTest();
				return allTests;
			}

		public static Test suite()
			{
				Test[] allTests = createAllTests();
				TestSuite suite = new TestSuite(SymCipherTest.class.getName());
				for (int i = 0; i < allTests.length; i++) 
				{
					suite.addTest(allTests[i]);
				}
				return suite;
			}
	}