package anon.infoservice.test;

import java.io.IOException;
import java.net.InetAddress;
import java.net.Socket;

import HTTPClient.HTTPClientSocketFactory;
import anon.infoservice.ANONAddress;
import anon.infoservice.InfoServiceDBEntry;
import anon.infoservice.InfoServiceHolder;
import anon.util.Util;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

public class InfoServiceANONAddressTest extends TestCase
	{
		
	
		
		protected void runTest()
			{
				try
					{
						InfoServiceHolder is = InfoServiceHolder.getInstance();
						InfoServiceDBEntry service=new InfoServiceDBEntry("infoservice.inf.tu-dresden.de",6543);
						is.setPreferredInfoService(service);
						String strID="42";
						String strAddress=null;//"testAddr";
						byte[] arBlindedKey=new byte[20];
						ANONAddress addr=new ANONAddress(strID,strAddress,arBlindedKey);
						is.postANONAddress(addr);
						ANONAddress a2=is.getANONAddress(strID);					
						assertNotNull(a2);
						String s = a2.getAddress();
						assertEquals(strAddress,s);
						byte[] b=a2.getBlindeyKey();
						assertTrue(Util.arraysEqual(arBlindedKey, b));
					}

				catch (Exception e)
					{
						e.printStackTrace();
						assertEquals(true, false);
						return;
					}
				assertEquals(true, true);

			}

		private static Test[] createAllTests()
			{
				Test[] allTests = new Test[1];
				allTests[0] = new InfoServiceANONAddressTest();
				return allTests;
			}

		public static Test suite()
			{
				Test[] allTests = createAllTests();
				TestSuite suite = new TestSuite(InfoServiceANONAddressTest.class.getName());
				for (int i = 0; i < allTests.length; i++)
					{
						suite.addTest(allTests[i]);
					}
				return suite;
			}
	}
