package anon.infoservice.test;

import java.io.IOException;
import java.net.InetAddress;
import java.net.Socket;

import HTTPClient.HTTPClientSocketFactory;
import anon.infoservice.InfoServiceDBEntry;
import anon.infoservice.InfoServiceHolder;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

public class InfoServiceDNSQueryTest extends TestCase
	{
		
		class TestSocketFactory implements HTTPClientSocketFactory
		{
		
			public Socket connect(InetAddress host, int port) throws IOException
				{
					return new Socket(host,port);
				}
			
		}
		
		protected void runTest()
			{
				try
					{
						InfoServiceHolder is = InfoServiceHolder.getInstance();
						is.setSocketFactory(new TestSocketFactory());
						InfoServiceDBEntry service=new InfoServiceDBEntry("infoservice.inf.tu-dresden.de",80);
						is.setPreferredInfoService(service);
						InetAddress[] addrs = is.doDNSQuery("mix.inf.tu-dresden.de");
						assertNotNull(addrs);
						addrs = is.doDNSQuery("www.google.com");
						assertNotNull(addrs);
					}

				catch (Exception e)
					{
						e.printStackTrace();
						assertEquals(true, false);
						return;
					}
				assertEquals(true, true);

			}

		private static Test[] createAllTests()
			{
				Test[] allTests = new Test[1];
				allTests[0] = new InfoServiceDNSQueryTest();
				return allTests;
			}

		public static Test suite()
			{
				Test[] allTests = createAllTests();
				TestSuite suite = new TestSuite(InfoServiceDNSQueryTest.class.getName());
				for (int i = 0; i < allTests.length; i++)
					{
						suite.addTest(allTests[i]);
					}
				return suite;
			}
	}
