package anon.infoservice.test;

import java.util.Enumeration;
import java.util.Hashtable;

import anon.crypto.JAPCertificate;
import anon.crypto.SignatureVerifier;
import anon.crypto.CryptoUtil;
import anon.infoservice.InfoServiceDBEntry;
import anon.infoservice.InfoServiceHolder;
import anon.infoservice.MixCascade;
import anon.infoservice.StatusInfo;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import logging.LogHolder;
import logging.LogLevel;
import logging.LogType;

public class InfoServiceFetchCascadesTest extends TestCase
	{
		protected void runTest()
			{
				try
					{
						LogHolder.setLogInstance(new logging.SystemErrLog(LogLevel.DEBUG, LogType.ALL));
						LogHolder.setDetailLevel(LogHolder.DETAIL_LEVEL_HIGHEST);
						SignatureVerifier.getInstance().setCheckSignatures(true);
						CryptoUtil.addDefaultCertificates("mixCA/", JAPCertificate.CERTIFICATE_TYPE_ROOT_MIX);
						CryptoUtil.addDefaultCertificates("InfoServices/", JAPCertificate.CERTIFICATE_TYPE_INFOSERVICE);
						CryptoUtil.addDefaultCertificates("isCA/", JAPCertificate.CERTIFICATE_TYPE_ROOT_INFOSERVICE);
						
						InfoServiceHolder is = InfoServiceHolder.getInstance();
						is.setChangeInfoServices(false);
						is.setNumberOfAskedInfoServices(1);
						InfoServiceDBEntry service=new InfoServiceDBEntry("infoservice.inf.tu-dresden.de",6543);
						service.setConnectionTimeout(60000);
						is.setPreferredInfoService(service);
						Hashtable cascades=is.getMixCascades();
						assertNotNull(cascades);
						Enumeration enumer=cascades.elements();
						while(enumer.hasMoreElements())
							{
								MixCascade cascade=(MixCascade)enumer.nextElement();
								StatusInfo info=cascade.fetchCurrentStatus();
								assertNotNull(info);
								info=cascade.getCurrentStatus();
								System.out.println(cascade.toString());
							}
					}

				catch (Exception e)
					{
						e.printStackTrace();
						assertEquals(true, false);
						return;
					}
				assertEquals(true, true);
			}

		private static Test[] createAllTests()
			{
				Test[] allTests = new Test[1];
				allTests[0] = new InfoServiceFetchCascadesTest();
				return allTests;
			}

		public static Test suite()
			{
				Test[] allTests = createAllTests();
				TestSuite suite = new TestSuite(InfoServiceFetchCascadesTest.class.getName());
				for (int i = 0; i < allTests.length; i++)
					{
						suite.addTest(allTests[i]);
					}
				return suite;
			}
	}
