package anon.infoservice.test;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.util.Enumeration;
import java.util.Hashtable;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

import anon.crypto.SignatureVerifier;
import anon.infoservice.InfoServiceDBEntry;
import anon.infoservice.InfoServiceHolder;
import anon.infoservice.MixCascade;
import anon.util.XMLUtil;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

public class MixCascadeEntryLoadSaveTest extends TestCase
	{
		protected void runTest()
			{
				try
					{
						SignatureVerifier.getInstance().setCheckSignatures(false); //insecure, of course - but necessary for this simple manually added mix-cascade
						InfoServiceHolder is = InfoServiceHolder.getInstance();
						InfoServiceDBEntry service=new InfoServiceDBEntry("infoservice.inf.tu-dresden.de",80);
						service.setConnectionTimeout(60000);
						is.setPreferredInfoService(service);
						Hashtable cascades=is.getMixCascades();
						assertNotNull(cascades);
						Enumeration enumer=cascades.elements();
						Document doc=XMLUtil.createDocument();
						Element elemRoot=XMLUtil.createChildElement(doc,"MixCascades");
						while(enumer.hasMoreElements())
							{
								MixCascade cascade=(MixCascade)enumer.nextElement();
								Element elem=cascade.toXmlElement(doc);
								elemRoot.appendChild(elem);
							}
						ByteArrayOutputStream out=new ByteArrayOutputStream();
						XMLUtil.write(doc, out);
						System.out.println(new String(out.toByteArray(),"UTF8"));
						
						ByteArrayInputStream in=new ByteArrayInputStream(out.toByteArray());
						doc=XMLUtil.readXMLDocument(in);
						elemRoot=(Element)XMLUtil.getFirstChildByName(doc,"MixCascades");
						Node node=elemRoot.getFirstChild();
						Hashtable cascadesRead=new Hashtable();
						while(node!=null)
									{
										if(node.getNodeType()==Node.ELEMENT_NODE)
											{
												Element elem=(Element)node;
												MixCascade cascade=new MixCascade(elem);
												cascadesRead.put(cascade.getId(),cascade);
											}
										node=node.getNextSibling();
									}
						
						Enumeration keys=cascades.keys();
						while(keys.hasMoreElements())
							{
								assertTrue(cascadesRead.containsKey(keys.nextElement()));
							}
					}

				catch (Exception e)
					{
						e.printStackTrace();
						assertEquals(true, false);
						return;
					}
				assertEquals(true, true);
			}

		private static Test[] createAllTests()
			{
				Test[] allTests = new Test[1];
				allTests[0] = new MixCascadeEntryLoadSaveTest();
				return allTests;
			}

		public static Test suite()
			{
				Test[] allTests = createAllTests();
				TestSuite suite = new TestSuite(MixCascadeEntryLoadSaveTest.class.getName());
				for (int i = 0; i < allTests.length; i++)
					{
						suite.addTest(allTests[i]);
					}
				return suite;
			}
	}
