/*******************************************************************************
 * Copyright (c) 2006-2007 Koji Hisano <hisano@gmail.com> - UBION Inc. Developer
 * Copyright (c) 2006-2007 UBION Inc. <http://www.ubion.co.jp/>
 * 
 * Copyright (c) 2006-2007 Skype Technologies S.A. <http://www.skype.com/>
 * 
 * Skype4Java is licensed under either the Apache License, Version 2.0 or
 * the Eclipse Public License v1.0.
 * You may use it freely in commercial and non-commercial products.
 * You may obtain a copy of the licenses at
 *
 *   the Apache License - http://www.apache.org/licenses/LICENSE-2.0
 *   the Eclipse Public License - http://www.eclipse.org/legal/epl-v10.html
 *
 * If it is possible to cooperate with the publicity of Skype4Java, please add
 * links to the Skype4Java web site <https://developer.skype.com/wiki/Java_API> 
 * in your web site or documents.
 * 
 * Contributors:
 * Koji Hisano - initial API and implementation
 ******************************************************************************/
package com.skype.connector;

/**
 * This exception will be thrown when a command is sent to a connector but when the connector isn't connected.
 */
public final class ConnectorNotAttachedException extends ConnectorException {
    /**
	 * Needed for serialisation.
	 */
	private static final long serialVersionUID = 8424409627819350472L;

    /**
	 * The actual current status (Not attached).
	 */
	private final int status;

	/**
	 * Constructor with the current status.
	 * @param i Current status.
	 */
    ConnectorNotAttachedException(int i) {
        this.status = i;
    }

    ConnectorNotAttachedException(int newStatus, Throwable cause) {
        this(newStatus);
        initCause(cause);
    }

    /**
     * Return the status at the moment of the exception.
     * @return Status.
     */
    public int getStatus() {
        return status;
    }
}
